.486
.model flat, stdcall
option casemap: none

PNGBTN	equ	1
; API functions
; ************************************
include	AeroVistaButtons.inc
include lib\bmpbutn.asm

.const
; Resource ids
; ************************************
IDD_DLG1  	   equ 101
IDI_ICON       equ 200
IDC_BTN1	   equ 300
IDC_BTN2       equ 400
IDC_BTN3       equ 500

; Required data
; ************************************
.data?
hInstance HINSTANCE ?
hIcon     HICON     ?
hWND		dd	?
hExit		dd	?
hMin        dd	?
hMax        dd	?
hMinBox     dd	?
rct     RECT   <?>
WindowSz	dd	?
ButoonFlag  dd  ?
.code

start:


invoke GetModuleHandle, NULL
mov hInstance, eax

invoke LoadIcon, eax, IDI_ICON 
mov hIcon, eax
invoke InitCommonControls
invoke DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, SW_SHOWDEFAULT
invoke ExitProcess, 0


; Dialog procedure
; ************************************
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM

LOCAL ps:PAINTSTRUCT


.if uMsg == WM_INITDIALOG

;=============================================

        INVOKE  SizeBoxes,hWnd

;============================================= 
INVOKE GetClientRect,[hWnd],offset rct
INVOKE CreateRoundRectRgn,0,0,[rct.right],[rct.bottom],20,20
INVOKE SetWindowRgn,[hWnd],eax,TRUE


invoke ImageButton,hWnd,219,2,503,501,502,IDC_BTN1 ; Minimize    ;custom image button (JPG,BMP,PNG) Left,Up,DownID,UpID,OverID
mov hMin,eax
invoke ImageButton,hWnd,244,2,603,601,602,IDC_BTN2	;MaximizeBox	;custom image button (JPG,BMP,PNG) Left,Up,DownID,UpID,OverID
mov hMax,eax
invoke ImageButton,hWnd,270,2,703,701,702,IDC_BTN3 ; Exit	;custom image button (JPG,BMP,PNG) Left,Up,DownID,UpID,OverID
mov hExit,eax

INVOKE ShowWindow,hWnd,SW_SHOWNORMAL          ; deffult window start size
mov WindowSz,TRUE ; This is needed to let the WindowSz MaximizeBox/MinimizeBox Button control know-
; that the window state is already at "SW_SHOWNORMAL "!


.elseif  uMsg == WM_COMMAND


.if  wParam ==IDC_BTN1 ; Minimize Window Button   
invoke ShowWindow,hWnd,SW_MINIMIZE
.endif

.if   wParam ==IDC_BTN2 ; MaximizeBox/MinimizeBox Button  
.if WindowSz==TRUE
mov WindowSz,FALSE
;invoke ImageButton,hWnd,244,2,403,401,402,IDC_BTN2	;custom image button (JPG,BMP,PNG) Left,Up,DownID,UpID,OverID
;mov hMinBox,eax
invoke ShowWindow,hWnd,SW_MAXIMIZE


INVOKE CreateRoundRectRgn,0,0,edx,eax,20,20
INVOKE SetWindowRgn,[hWnd],eax,TRUE

.elseif WindowSz==FALSE
mov WindowSz,TRUE
;invoke ImageButton,hWnd,244,2,603,601,602,IDC_BTN2	;custom image button (JPG,BMP,PNG) Left,Up,DownID,UpID,OverID
;mov hMax,eax
invoke ShowWindow,hWnd,SW_SHOWNORMAL ; Restore Window to defult size (MinimizeBox)
INVOKE CreateRoundRectRgn,0,0,[rct.right],[rct.bottom],20,20
INVOKE SetWindowRgn,[hWnd],eax,TRUE

.endif
.endif

.if   wParam ==IDC_BTN3   ; Exit Button 
invoke SendMessage,hWnd,WM_CLOSE,0,0
.endif
;=============================================
.ELSEIF uMsg == WM_SIZE

INVOKE  SizeBoxes,hWnd

;============================================= 

.elseif uMsg == WM_LBUTTONDOWN
invoke SendMessage, hWnd, WM_NCLBUTTONDOWN,HTCAPTION, 0 ; Move non client area of window

.elseif  uMsg == WM_CLOSE 
invoke EndDialog, hWnd, 0
 .endif
 
    xor eax,eax
  ret
DialogProc endp
; Load Png procedure
; ************************************
LoadPng proc ID:DWORD,pSize:DWORD
local pngInfo:PNGINFO

invoke PNG_Init, addr pngInfo
invoke PNG_LoadResource, addr pngInfo, hInstance, ID
.if !eax
xor eax, eax
jmp @cleanup
.endif
invoke PNG_Decode, addr pngInfo
.if !eax
xor eax, eax
jmp @cleanup
.endif
invoke PNG_CreateBitmap, addr pngInfo, hWND, PNG_OUTF_AUTO, FALSE
.if	!eax
xor eax, eax
jmp @cleanup
.endif
mov edi,pSize
.if edi!=0
lea esi,pngInfo
movsd
movsd
.endif

@cleanup:
push eax	
invoke PNG_Cleanup, addr pngInfo

pop eax
ret

LoadPng endp
; Size Box procedure
; ************************************
SizeBoxes proc uses ebx esi edi hWnd:HWND

        mov     ebx,hWnd                     ;EBX = hWnd
        xor     edi,edi                      ;EDI = 0
        sub     esp,sizeof RECT
        INVOKE  GetWindowRect,ebx,esp
        pop     edx                          ;discard RECT.left
        pop     ecx                          ;discard RECT.top
        INVOKE  ScreenToClient,ebx,esp
        pop     esi                          ;ESI = RECT.right
        pop     eax                          ;discard RECT.bottom
        INVOKE  GetDlgItem,ebx,IDC_BTN3
        sub     esi,70 ; 70 move the button in , were as if the value was 25 the button would move to the righ
        INVOKE  MoveWindow,eax,esi,edi,45,45,TRUE
        INVOKE  GetDlgItem,ebx,IDC_BTN2
        sub     esi,23
        INVOKE  MoveWindow,eax,esi,edi,24,24,TRUE
        INVOKE  GetDlgItem,ebx,IDC_BTN1
        sub     esi,23
        INVOKE  MoveWindow,eax,esi,edi,24,24,TRUE
        ret

SizeBoxes endp
end start